Index: pplinux/linuxnew/drivers/i2c/i2c-ibm_iic.c
diff -u pplinux/linuxnew/drivers/i2c/i2c-ibm_iic.c:1.1.323.1 pplinux/linuxnew/drivers/i2c/i2c-ibm_iic.c:1.3
--- pplinux/linuxnew/drivers/i2c/i2c-ibm_iic.c:1.1.323.1	Thu Feb  3 10:00:38 2005
+++ pplinux/linuxnew/drivers/i2c/i2c-ibm_iic.c	Fri Apr 29 10:43:29 2005
@@ -37,11 +37,16 @@
 #include <asm/io.h>
 #include <linux/i2c.h>
 #include <linux/i2c-id.h>
+#include <linux/i2c-slave.h>
 #include <asm/ocp.h>
+#include <asm/errno.h>
+#include <asm/uaccess.h>
 
 #include "i2c-ibm_iic.h"
 
-#define DRIVER_VERSION "2.0"
+#define BUS_TIMEOUT	1
+
+#define DRIVER_VERSION "2.1"
 
 MODULE_DESCRIPTION("IBM IIC driver v" DRIVER_VERSION);
 MODULE_LICENSE("GPL");
@@ -56,19 +61,36 @@
 
 static int iic_force_fast = 0;
 MODULE_PARM(iic_force_fast, "i");
-MODULE_PARM_DESC(iic_fast_poll, "Force fast mode (400 kHz)");
+MODULE_PARM_DESC(iic_force_fast, "Force fast mode (400 kHz)");
+
+static int iic_own_addr = 0x55;
+MODULE_PARM(iic_own_addr, "i");
+MODULE_PARM_DESC(iic_own_addr, "Our own slave address");
+
+/* slave mode */
+static void iic_slave_init(void);
+static void iic_handle_slave(struct ibm_iic_private* dev,
+			     unsigned char status,
+			     unsigned char ext_status,
+			     unsigned char slave_status,
+			     unsigned char xfer_cnt);
+static int iic_slave_set_address(struct i2c_adapter *adap,
+                                 unsigned int address);
+static int iic_slave_restart_xfer(struct i2c_adapter* adapter);
+static int iic_slave_init_adapter(struct i2c_adapter* adapter);
+static int iic_slave_cleanup_adapter(void);
 
 #define DBG_LEVEL 0
 
 #if DBG_LEVEL > 0
-#  define DBG(x...)	printk(KERN_DEBUG "ibm-iic" ##x)
+#  define DBG(fmt, x...)	printk(KERN_DEBUG "ibm-iic" fmt, ##x)
 #else
-#  define DBG(x...)	((void)0)
+#  define DBG(fmt, x...)	((void)0)
 #endif
 #if DBG_LEVEL > 1
-#  define DBG2(x...) 	DBG( ##x )
+#  define DBG2(fmt, x...) 	DBG( fmt, ##x )
 #else
-#  define DBG2(x...) 	((void)0)
+#  define DBG2(fmt, x...) 	((void)0)
 #endif
 #if DBG_LEVEL > 2
 static void dump_iic_regs(const char* header, struct ibm_iic_private* dev)
@@ -78,20 +100,60 @@
 	printk(KERN_DEBUG "  cntl     = 0x%02x, mdcntl = 0x%02x\n"
 	       KERN_DEBUG "  sts      = 0x%02x, extsts = 0x%02x\n"
 	       KERN_DEBUG "  clkdiv   = 0x%02x, xfrcnt = 0x%02x\n"
-	       KERN_DEBUG "  xtcntlss = 0x%02x, directcntl = 0x%02x\n",
+	       KERN_DEBUG "  xtcntlss = 0x%02x, directcntl = 0x%02x\n"
+#if DBG_LEVEL > 3
+	       KERN_DEBUG "  lmadr    = 0x%02x, hmadr  = 0x%02x\n"
+	       KERN_DEBUG "  lsadr    = 0x%02x, hsadr  = 0x%02x\n"
+	       KERN_DEBUG "  intmsk   = 0x%02x\n"
+#endif
+	       ,
 		in_8(&iic->cntl), in_8(&iic->mdcntl), in_8(&iic->sts), 
 		in_8(&iic->extsts), in_8(&iic->clkdiv), in_8(&iic->xfrcnt), 
-		in_8(&iic->xtcntlss), in_8(&iic->directcntl));
+		in_8(&iic->xtcntlss), in_8(&iic->directcntl)
+#if DBG_LEVEL > 3
+		,
+		in_8(&iic->lmadr), in_8(&iic->hmadr),
+		in_8(&iic->lsadr), in_8(&iic->hsadr),
+		in_8(&iic->intmsk)
+#endif
+		);
 }
 #  define DUMP_REGS(h,dev)	dump_iic_regs((h),(dev))
 #else
 #  define DUMP_REGS(h,dev)	((void)0)
 #endif
 
+#define WARN(fmt, x...)	printk(KERN_WARNING "ibm-iic" fmt, ##x)
+
+/* Bus timings (in ns) for bit-banging */
+static struct i2c_timings {
+	unsigned int hd_sta;
+	unsigned int su_sto;
+	unsigned int low;
+	unsigned int high;
+	unsigned int buf;
+} timings [] = {
+/* Standard mode (100 KHz) */
+{
+	.hd_sta= 4000,
+	.su_sto= 4000,
+	.low= 4700,
+	.high= 4000,
+	.buf= 4700,
+},
+/* Fast mode (400 KHz) */
+{
+	.hd_sta = 600,
+	.su_sto= 600,
+	.low = 1300,
+	.high = 600,
+	.buf= 1300,
+}};
+
 /* Enable/disable interrupt generation */
 static inline void iic_interrupt_mode(struct ibm_iic_private* dev, int enable)
 {
-	out_8(&dev->vaddr->intmsk, enable ? INTRMSK_EIMTC : 0);
+	out_8(&dev->vaddr->intmsk, enable ? INTRMSK_EIRC | INTRMSK_EIRS | INTRMSK_EIMTC | INTRMSK_EIWC | INTRMSK_EIWS : 0);
 }
  
 /*
@@ -102,13 +164,13 @@
 	volatile struct iic_regs *iic = dev->vaddr;
 
 	DBG("%d: init\n", dev->idx);
-	
+
 	/* Clear master address */
 	out_8(&iic->lmadr, 0);
 	out_8(&iic->hmadr, 0);
 
-	/* Clear slave address */
-	out_8(&iic->lsadr, 0);
+	/* Set slave address */
+	out_8(&iic->lsadr, iic_own_addr << 1);
 	out_8(&iic->hsadr, 0);
 
 	/* Clear status & extended status */
@@ -133,8 +195,9 @@
 	iic_interrupt_mode(dev, dev->irq >= 0);
 
 	/* Set mode control */
-	out_8(&iic->mdcntl, MDCNTL_FMDB | MDCNTL_EINT | MDCNTL_EUBS
-			    | (dev->fast_mode ? MDCNTL_FSM : 0));
+	out_8(&iic->mdcntl, MDCNTL_FSDB | MDCNTL_FMDB | MDCNTL_ESM
+	      | MDCNTL_EINT | MDCNTL_EUBS | MDCNTL_HSCL
+	      | (dev->fast_mode ? MDCNTL_FSM : 0));
 
 	DUMP_REGS("iic_init", dev);
 }
@@ -189,18 +252,135 @@
 }
 
 /*
+ * Do 0-length transaction using bit-banging through IIC_DIRECTCNTL register.
+ */
+
+/* Wait for SCL and/or SDA to be high */
+static int iic_dc_wait(volatile struct iic_regs *iic, u8 mask)
+{
+	unsigned long x = jiffies + HZ / 28 + 2;
+	while ((in_8(&iic->directcntl) & mask) != mask){
+		if (unlikely(time_after(jiffies, x)))
+			return -1;
+		cond_resched();
+	}
+	return 0;
+}
+
+static int iic_smbus_quick(struct ibm_iic_private* dev, const struct i2c_msg* p)
+{
+	volatile struct iic_regs* iic = dev->vaddr;
+	const struct i2c_timings* t = &timings[dev->fast_mode ? 1 : 0];
+	u8 mask, v, sda;
+	int i, res;
+
+	/* Only 7-bit addresses are supported */
+	if (unlikely(p->flags & I2C_M_TEN)){
+		DBG("%d: smbus_quick - 10 bit addresses are not supported\n",
+			dev->idx);
+		return -EINVAL;
+	}
+
+	DBG("%d: smbus_quick(0x%02x)\n", dev->idx, p->addr);
+	
+	/* Reset IIC interface */
+	out_8(&iic->xtcntlss, XTCNTLSS_SRST);
+
+	/* Wait for bus to become free */
+	out_8(&iic->directcntl, DIRCNTL_SDAC | DIRCNTL_SCC);
+	if (unlikely(iic_dc_wait(iic, DIRCNTL_MSDA | DIRCNTL_MSC)))
+		goto err;
+	ndelay(t->buf);
+
+	/* START */
+	out_8(&iic->directcntl, DIRCNTL_SCC);
+	sda = 0;
+	ndelay(t->hd_sta);
+
+	/* Send address */
+	v = (u8)((p->addr << 1) | ((p->flags & I2C_M_RD) ? 1 : 0));
+	for (i = 0, mask = 0x80; i < 8; ++i, mask >>= 1){
+		out_8(&iic->directcntl, sda);
+		ndelay(t->low / 2);
+		sda = (v & mask) ? DIRCNTL_SDAC : 0;
+		out_8(&iic->directcntl, sda);
+		ndelay(t->low / 2);
+
+		out_8(&iic->directcntl, DIRCNTL_SCC | sda);
+		if (unlikely(iic_dc_wait(iic, DIRCNTL_MSC)))
+			goto err;
+		ndelay(t->high);
+	}
+
+	/* ACK */
+	out_8(&iic->directcntl, sda);
+	ndelay(t->low / 2);
+	out_8(&iic->directcntl, DIRCNTL_SDAC);
+	ndelay(t->low / 2);
+	out_8(&iic->directcntl, DIRCNTL_SDAC | DIRCNTL_SCC);
+	if (unlikely(iic_dc_wait(iic, DIRCNTL_MSC)))
+		goto err;
+	res = (in_8(&iic->directcntl) & DIRCNTL_MSDA) ? -EREMOTEIO : 1;
+	ndelay(t->high);
+
+	/* STOP */
+	out_8(&iic->directcntl, 0);
+	ndelay(t->low);
+	out_8(&iic->directcntl, DIRCNTL_SCC);
+	if (unlikely(iic_dc_wait(iic, DIRCNTL_MSC)))
+		goto err;
+	ndelay(t->su_sto);
+	out_8(&iic->directcntl, DIRCNTL_SDAC | DIRCNTL_SCC);
+
+	ndelay(t->buf);
+
+	DBG("%d: smbus_quick -> %s\n", dev->idx, res < 0 ? "NACK" : "ACK");
+out:
+	/* Remove reset */
+	out_8(&iic->xtcntlss, 0);
+
+	/* Reinitialize interface */
+	iic_dev_init(dev);
+
+	return res;
+err:
+	DBG("%d: smbus_quick - bus is stuck\n", dev->idx);
+	res = -EREMOTEIO;
+	goto out;
+}
+
+/*
  * IIC interrupt handler
  */
 static void iic_handler(int irq, void *dev_id, struct pt_regs *regs)
 {
 	struct ibm_iic_private* dev = (struct ibm_iic_private*)dev_id;
 	volatile struct iic_regs* iic = dev->vaddr;
+	unsigned char status, ext_status, slave_status, xfer_cnt;
+
+	status = in_8(&iic->sts);
+	ext_status = in_8(&iic->extsts);
+	slave_status = in_8(&iic->xtcntlss);
+	xfer_cnt = in_8(&iic->xfrcnt);
+
+	DBG2("%d: irq handler, STS = 0x%02x, EXTSTS = 0x%02x, XTCNTLSS = 0x%02x\n", 
+	     dev->idx, status, ext_status, slave_status);
+#if DBG_LEVEL > 2
+	DBG2("%d: irq handler, CNTL = 0x%02x, MDCNTL = 0x%02x, DIRECTCNTL = 0x%02x, XFRCNT = 0x%02x\n",
+	     dev->idx, in_8(&iic->cntl), in_8(&iic->mdcntl),
+	     in_8(&iic->directcntl), xfer_cnt);
+#endif
 	
-	DBG2("%d: irq handler, STS = 0x%02x, EXTSTS = 0x%02x\n", 
-	     dev->idx, in_8(&iic->sts), in_8(&iic->extsts));
+
+	/* look if we got a slave related irq */
+	if (slave_status & (XTCNTLSS_SWC | XTCNTLSS_SWS | XTCNTLSS_SRS | XTCNTLSS_SRC)) {
+		iic_handle_slave(dev, status, ext_status, slave_status, xfer_cnt);
+	}
 	
 	/* Acknowledge IRQ and wakeup iic_wait_for_tc */
-	out_8(&iic->sts, STS_IRQA | STS_SCMP);
+	out_8(&iic->extsts, ext_status);
+	out_8(&iic->sts, status);
+
 	wake_up_interruptible(&dev->wq);
 }
 
@@ -273,6 +453,7 @@
  * It puts current process to sleep until we get interrupt or timeout expires.
  * Returns the number of transferred bytes or error (<0)
  */
+
 static int iic_wait_for_tc(struct ibm_iic_private* dev){
 	
 	volatile struct iic_regs *iic = dev->vaddr;
@@ -425,11 +606,16 @@
  * Generic master transfer entrypoint. 
  * Returns the number of processed messages or error (<0)
  */
+
+#define BUS_WAIT_TIME		100
+#define BUS_WAIT_RETRIES	1000
+
 static int iic_xfer(struct i2c_adapter *adap, struct i2c_msg msgs[], int num)
 {
     	struct ibm_iic_private* dev = (struct ibm_iic_private*)(adap->data);
 	volatile struct iic_regs *iic = dev->vaddr;
 	int i, ret = 0;
+	u8 extsts;
 	
 	DBG2("%d: iic_xfer, %d msg(s)\n", dev->idx, num);
 	
@@ -446,6 +632,13 @@
 	}		
 	for (i = 0; i < num; ++i){
 		if (unlikely(msgs[i].len <= 0)){
+			if (num == 1 && !msgs[0].len){
+				/* Special case for I2C_SMBUS_QUICK emulation.
+				 * IBM IIC doesn't support 0-length transactions
+				 * so we have to emulate them using bit-banging.
+				 */
+				return iic_smbus_quick(dev, &msgs[0]);
+			}
 			DBG("%d: invalid len %d in msg[%d]\n", dev->idx, 
 				msgs[i].len, i);
 			return -EINVAL;
@@ -457,21 +650,28 @@
 	}
 	
 	/* Check bus state */
-	if (unlikely((in_8(&iic->extsts) & EXTSTS_BCS_MASK) != EXTSTS_BCS_FREE)){
+	if (unlikely(((extsts = in_8(&iic->extsts)) & EXTSTS_BCS_MASK) != EXTSTS_BCS_FREE)){
+		int retries = 0;
 		DBG("%d: iic_xfer, bus is not free\n", dev->idx);
 		
-		/* Usually it means something serious has happend.
-		 * We *cannot* have unfinished previous transfer
-		 * so it doesn't make any sense to try to stop it.
-		 * Probably we were not able to recover from the 
-		 * previous error.
-		 * The only *reasonable* thing I can think of here
-		 * is soft reset.  --ebs
+		/* There might be another operation in progress,
+		 * (slave operation). Wait for it to end.
+		 */
+		do {
+			udelay(BUS_WAIT_TIME);
+			retries++;
+			extsts = in_8(&iic->extsts);
+		} while (((extsts & EXTSTS_BCS_MASK) != EXTSTS_BCS_FREE) && retries < BUS_WAIT_RETRIES);
+		
+		/* If the bus is still not free, reset the i2c interface
 		 */
-		iic_dev_reset(dev);
+		if ((extsts & EXTSTS_BCS_MASK) != EXTSTS_BCS_FREE) {
+			WARN("%d: iic_xfer, bus is still not free, resetting\n", dev->idx);
+			iic_dev_reset(dev);
+		}
 		
 		if ((in_8(&iic->extsts) & EXTSTS_BCS_MASK) != EXTSTS_BCS_FREE){
-			DBG("%d: iic_xfer, bus is still not free\n", dev->idx);
+			WARN("%d: iic_xfer, bus is still not free\n", dev->idx);
 			return -EREMOTEIO;
 		}
 	} 
@@ -479,7 +679,7 @@
 		/* Flush master data buffer (just in case) */
 		out_8(&iic->mdcntl, in_8(&iic->mdcntl) | MDCNTL_FMDB);
 	}
-	
+		
 	/* Load slave address */
 	iic_address(dev, &msgs[0]);
 	
@@ -490,6 +690,22 @@
 	return ret < 0 ? ret : num;
 }
 
+static int iic_algo_control(struct i2c_adapter *adap, 
+			    unsigned int cmd, unsigned long arg)
+{
+	switch (cmd) {
+	  case I2C_SLAVE_SET_ADDRESS:
+		iic_slave_set_address(adap, (unsigned int) arg);
+		break;
+	  case I2C_SLAVE_FLUSH_BUFFER:
+		iic_slave_restart_xfer(adap);
+		break;
+	  default:
+		return -1;
+	}
+	return 0;
+}
+
 static u32 iic_func(struct i2c_adapter *adap)
 {
 	return I2C_FUNC_I2C | I2C_FUNC_SMBUS_EMUL | I2C_FUNC_10BIT_ADDR;
@@ -502,10 +718,12 @@
 	.smbus_xfer	= NULL,
 	.slave_send	= NULL,
 	.slave_recv	= NULL,
-	.algo_control	= NULL,
+	.algo_control	= iic_algo_control,
 	.functionality	= iic_func
 };
 
+
+
 /*
  * Scan bus for valid 7-bit addresses (ie things that ACK on 1 byte read)
  * We only scan range [0x08 - 0x77], all other addresses are reserved anyway
@@ -625,11 +843,11 @@
 	/* clckdiv is the same for *all* IIC interfaces, 
 	 * but I'd rather make a copy than introduce another global. --ebs
 	 */
-	dev->clckdiv = iic_clckdiv(bd->bi_opbfreq);
+	dev->clckdiv = iic_clckdiv(bd->bi_opb_busfreq);
 	DBG("%d: clckdiv = %d\n", dev->idx, dev->clckdiv);
 	
-	/* Initialize IIC interface */
-	iic_dev_init(dev);
+	/* Reset and reinitialize IIC interface */
+	iic_dev_reset(dev);
 	
 	/* Register it with i2c layer */
 	adap = &dev->adap;
@@ -641,7 +859,7 @@
 	adap->dec_use = iic_dec_use;
 	adap->client_register = NULL;
 	adap->client_unregister = NULL;
-	adap->timeout = 1;
+	adap->timeout = BUS_TIMEOUT;
 	adap->retries = 1;
 
 	if ((ret = i2c_add_adapter(adap)) != 0){
@@ -657,6 +875,11 @@
 	if (iic_scan)
 		iic_scan_bus(dev);
 
+	/* register slave mode */
+	if (iic_slave_init_adapter(adap) != 0) {
+		goto fail;
+	}
+	
 	return 0;
 
 fail:	
@@ -696,6 +919,9 @@
 		iounmap((void*)dev->vaddr);
 		kfree(dev);
 	}
+	
+	/* register slave mode */
+	iic_slave_cleanup_adapter();
 }
 
 static struct ocp_device_id ibm_iic_ids[] =
@@ -721,6 +947,10 @@
 		ocp_unregister_driver(&ibm_iic_driver);
 		return -ENODEV;
 	}
+	
+	/* Initialize slave mode */
+	iic_slave_init();
+
 	return 0;
 }
 
@@ -729,5 +959,458 @@
 	ocp_unregister_driver(&ibm_iic_driver);
 }
 
+/*****************************************************************************
+ * slave mode functions
+ ****************************************************************************/
+
+#define SLAVE_BUF_SIZE 512
+
+/* slave lock object */
+static spinlock_t      slave_lock = SPIN_LOCK_UNLOCKED;
+
+/* slave write buffer */
+static unsigned char * slave_write_ptr;
+static unsigned int    slave_write_count;
+static unsigned char   slave_write_buffer[SLAVE_BUF_SIZE];
+
+/* slave read buffer */
+static unsigned char * slave_read_ptr;
+static unsigned int    slave_read_count;
+static unsigned char   slave_read_buffer[SLAVE_BUF_SIZE];
+
+/* status flags */
+static int block_next_slave_operation = 0;
+static int slave_write_was_blocked = 0;
+static int blocked_write_msg_complete = 0;
+static int slave_read_was_blocked = 0;
+static int blocked_read_msg_read_cmd = 0;
+
+/* function prototypes */
+static unsigned char iic_handle_slave_write(struct ibm_iic_private* dev,
+                                            unsigned char slave_status);
+static int iic_handle_slave_write_complete(struct ibm_iic_private* dev);
+static unsigned char iic_handle_slave_read(struct ibm_iic_private* dev,
+                                           unsigned char slave_status,
+                                           int read_command);
+
+/* Initialize slave buffers */
+static void iic_slave_init()
+{
+	unsigned long flags;
+
+        spin_lock_irqsave(&slave_lock, flags);
+        slave_write_ptr = slave_write_buffer;
+        slave_write_count = 0;
+        slave_read_ptr = slave_read_buffer;
+        slave_read_count = 0;
+        spin_unlock_irqrestore(&slave_lock, flags);
+}
+
+struct i2c_slave_adapter slave_adapt;
+
+/* register adapter in slave layer */
+static int iic_slave_init_adapter(struct i2c_adapter *adap)
+{
+	struct ibm_iic_private* dev = (struct ibm_iic_private*)(adap->data);
+	int ret = 0;
+
+	slave_adapt.adapter = adap;
+	slave_adapt.reactivate = iic_slave_restart_xfer;
+	if ((ret = i2c_slave_add_adapter(&slave_adapt)) != 0){
+		printk(KERN_CRIT "ibm-iic%d: failed to register i2c slave adapter\n",
+			dev->idx);
+		return ret;
+	}
+	
+	return 0;
+}
+
+/* deregister */
+static int iic_slave_cleanup_adapter()
+{
+	struct ibm_iic_private* dev;
+	struct i2c_adapter *adap;
+	int ret;
+	
+	adap = slave_adapt.adapter;
+	dev = (struct ibm_iic_private*)(adap->data);
+	
+	if ((ret = i2c_slave_remove_adapter(&slave_adapt)) != 0){
+		printk(KERN_CRIT "ibm-iic%d: failed to deregister i2c slave adapter\n",
+			dev->idx);
+		return ret;
+	}
+	
+	return 0;
+}
+
+/* set own slave address */
+static int iic_slave_set_address(struct i2c_adapter *adap, unsigned int address)
+{
+	struct ibm_iic_private* dev = (struct ibm_iic_private*)(adap->data);
+	volatile struct iic_regs *iic = dev->vaddr;
+	unsigned char reg;
+
+	reg = in_8(&iic->mdcntl);
+	out_8(&iic->mdcntl, reg & ~MDCNTL_ESM);
+	out_8(&iic->lsadr, (address & 0x7f) << 1);
+	out_8(&iic->hsadr, 0);
+	out_8(&iic->mdcntl, reg | (MDCNTL_FSDB | MDCNTL_ESM));
+	DBG ("%d: set i2c slave address to 0x%x\n", dev->idx, address);
+	reg = in_8(&iic->lsadr);
+	if (((reg >> 1) & 0x7f) != address) {
+		printk(KERN_WARNING "ibm-iic%d: could not set i2c slave address, result is 0x%02x",
+			dev->idx, reg);
+	}
+	DBG ("%d: verify slave address: 0x%02x\n", dev->idx, reg);
+	
+	return 0;
+}
+
+/* after the bus is gone down, reactivate transfer */
+static int iic_slave_restart_xfer(struct i2c_adapter* adapter)
+{
+    	struct ibm_iic_private* dev = (struct ibm_iic_private*)(adapter->data);
+	volatile struct iic_regs *iic = dev->vaddr;	
+	unsigned char slave_status;
+	unsigned long flags;
+	
+        spin_lock_irqsave(&slave_lock, flags);
+        
+        /* the next message shall be blocked, but no blocked message read yet
+           --> just deliver the last message */
+        if (block_next_slave_operation && !slave_write_was_blocked && !slave_read_was_blocked) {
+        	block_next_slave_operation = 0;
+		if (iic_handle_slave_write_complete(dev) < 0) {
+			DBG("%d: cannot put data to i2c-slave layer, next operation will be blocked.\n",
+				dev->idx);
+			block_next_slave_operation = 1;
+			
+			goto bail;
+		}
+        }
+        else {
+        	block_next_slave_operation = 0;
+        }
+        
+        if (slave_write_was_blocked) {
+        	/* deliver the last message */
+		if (iic_handle_slave_write_complete(dev) < 0) {
+			DBG("%d: cannot put data to i2c-slave layer, next operation will be blocked.\n",
+				dev->idx);
+			block_next_slave_operation = 1;
+			
+			goto bail;
+		}
+		
+		/* read the next message, if the flush of the first message succeeded */
+		slave_status = in_8(&iic->xtcntlss);
+		
+		slave_status = iic_handle_slave_write(dev, slave_status);
+		
+		/* deliver the next message if complete */
+		if (blocked_write_msg_complete) {
+			if (iic_handle_slave_write_complete(dev) < 0) {
+				DBG("%d: cannot put data to i2c-slave layer, next operation will be blocked.\n",
+					dev->idx);
+				block_next_slave_operation = 1;
+			}
+		}
+		
+		DUMP_REGS("iic_slave_restart_xfer", dev);
+		
+		out_8(&iic->xtcntlss, slave_status);
+        }
+        
+        if (slave_read_was_blocked) {
+		slave_status = in_8(&iic->xtcntlss);
+		
+		/* don't handle the read request here, no master will read data */
+		/* slave_status = iic_handle_slave_read(dev, slave_status, blocked_read_msg_read_cmd); */
+
+		out_8(&iic->xtcntlss, slave_status);
+        }
+
+bail:
+        spin_unlock_irqrestore(&slave_lock, flags);
+        
+        return 0;
+}
+
+/* handle i2c slave write requests */
+static unsigned char iic_handle_slave_write(struct ibm_iic_private* dev,
+                                            unsigned char slave_status)
+{
+	volatile struct iic_regs *iic = dev->vaddr;	
+
+	/* write bytes received to buffer */
+	while (slave_status & XTCNTLSS_SBDD) {
+		slave_write_count++;
+
+		*slave_write_ptr = in_8((volatile u8 *)&iic->sbbuf);
+
+		DBG2("%d: iic_handle_slave_write: putting byte 0x%02x (slave_status=0x%02x)\n",
+			dev->idx, *slave_write_ptr, slave_status);
+
+		/* avoid buffer overrun here */
+		if (slave_write_ptr < slave_write_buffer + SLAVE_BUF_SIZE) {
+			slave_write_ptr++;
+		}
+
+		slave_status = in_8(&iic->xtcntlss);
+	}
+
+	return slave_status;
+}
+
+/* if a slave write is complete, push the data up
+   to the upper i2c-slave level */
+static int iic_handle_slave_write_complete(struct ibm_iic_private* dev)
+{
+	int ret = 0;
+	struct i2c_adapter *adap = &dev->adap;
+	
+	if (slave_write_count <= 0) {
+		return slave_write_count;
+	}
+	
+	/* copy the written data to the upper I2C slave layer */
+	int written_bytes = iic_slave_write(adap, slave_write_buffer, slave_write_count);
+	if (written_bytes < 0) {
+		printk(KERN_WARNING "ibm-iic%d: iic_handle_slave_write_complete: error exporting data to i2c-slave layer: %d!\n",
+			dev->idx, written_bytes);
+		ret = -ENOMEM;
+	}
+	else if (written_bytes == 0) {
+		DBG2("%d: iic_handle_slave_write_complete: 0 bytes to i2c-slave layer exported!\n",
+			dev->idx);
+	}
+	else if (written_bytes >= slave_write_count) {
+		DBG2("%d: iic_handle_slave_write_complete: moved %d bytes to i2c-slave layer.\n",
+			dev->idx, written_bytes);
+		slave_write_ptr = slave_write_buffer;
+		slave_write_count = 0;
+	}
+	else {
+		// only a partial copy
+		DBG2("%d: iic_handle_slave_write_complete: moved %d bytes to i2c-slave layer, %d bytes requested.\n",
+			dev->idx, written_bytes, slave_write_count);
+		slave_write_ptr -= written_bytes;
+		slave_write_count -= written_bytes;
+	}
+	
+	return ret;
+}
+
+/* handle first slave read interrupt of an i2c message
+   fetches data from upper i2c slave level */
+static void iic_handle_slave_first_read(struct ibm_iic_private* dev,
+                                        int command)
+{
+	struct i2c_adapter *adap = &dev->adap;
+
+	DBG2("%d: iic_handle_slave_first_read: Fetching slave read data from i2c-slave layer.\n", dev->idx);
+	
+        slave_read_ptr = slave_read_buffer;
+        slave_read_count = iic_slave_read(adap, slave_read_buffer, SLAVE_BUF_SIZE, command);
+        
+        if (slave_read_count > 0) {
+        	DBG2("%d: iic_handle_slave_first_read: Got %d bytes.\n", dev->idx, slave_read_count);
+        }
+        else {
+        	DBG("%d: iic_handle_slave_first_read: cannot read bytes.\n", dev->idx);
+        }
+}
+
+/* handle an i2c slave read request */
+static unsigned char iic_handle_slave_read(struct ibm_iic_private* dev,
+                                           unsigned char slave_status,
+                                           int read_command)
+{
+	volatile struct iic_regs *iic = dev->vaddr;	
+
+	int command_read = 0;
+	int command = 0;
+	unsigned char data = 0;
+	
+	while (read_command && (slave_status & XTCNTLSS_SBDD)) {
+		command_read = 1;
+		command <<= 8;
+		command |= in_8((volatile u8 *)&iic->sbbuf) & 0xff;
+		DBG2("%d: iic_handle_slave_read: read command 0x%02x\n",
+			dev->idx, command);
+		slave_status = in_8(&iic->xtcntlss);
+	}
+	
+	if (!command_read) {
+		command = -1;
+	}
+	
+	if (slave_read_count <= 0) {
+		iic_handle_slave_first_read(dev, command);
+	}
+	
+	if (slave_read_count > 0) {
+		/* avoid buffer overrun here */
+		if (slave_read_ptr < slave_read_buffer + slave_read_count) {
+			data = *slave_read_ptr;
+			slave_read_ptr++;
+		}
+		else {
+			/* TODO: error handline here */
+			data = 0;
+			DBG("%d: iic_handle_slave_read: no data!\n", dev->idx);
+		}
+		
+		DBG2("%d: iic_handle_slave_read: sending byte 0x%02x\n", dev->idx, data);
+		
+		out_8((volatile u8 *)&iic->sbbuf, data);
+	}
+	else {
+		/* TODO: signal that we are not ready by not sending data */
+		out_8((volatile u8 *)&iic->sbbuf, 0);
+		DBG2("%d: iic_handle_slave_read: not ready, sending no byte\n", dev->idx);
+	}
+	
+	slave_status = in_8(&iic->xtcntlss);
+
+	return slave_status;
+}
+
+/* slave read completed */
+static void iic_handle_slave_read_complete(struct ibm_iic_private* dev)
+{
+	if (slave_read_ptr < slave_read_buffer + slave_read_count) {
+		DBG2("%d: iic_handle_slave_read_complete: not all data was read! amount: %d, read: %d\n",
+			dev->idx, slave_read_count, slave_read_ptr - slave_read_buffer);
+	}
+        else {
+		DBG2("%d: iic_handle_slave_read_complete: read %d bytes\n", dev->idx, slave_read_ptr - slave_read_buffer);
+	}
+	
+	slave_read_ptr = slave_read_buffer;
+	slave_read_count = 0;
+}
+
+/* handle iic slave interrupt */
+static void iic_handle_slave(struct ibm_iic_private* dev,
+			     unsigned char status,
+			     unsigned char ext_status,
+			     unsigned char slave_status,
+			     unsigned char xfer_cnt)
+{
+	volatile struct iic_regs *iic = dev->vaddr;	
+	unsigned char count;
+	unsigned long flags;
+	
+	int is_slave_write_request = 0;
+	int is_slave_write_complete = 0;
+	int is_slave_read_request = 0;
+	int is_slave_read_complete = 0;
+	int slave_read_get_command = 0;
+
+	spin_lock_irqsave(&slave_lock, flags);
+
+	count = xfer_cnt;
+	count = count >> 4;
+	DBG2("%d: iic_handle_slave: slave count=0x%02x\n", dev->idx, count);
+	
+	/* find out which slave operation is to be performed */
+	
+	if (slave_status & XTCNTLSS_SWS) {
+		is_slave_write_request = 1;
+	}
+	if (slave_status & XTCNTLSS_SWC) {
+#if 1
+		/* I don't know how to savely detect a slave read operation,
+		   so we don't use it. So we assume that a slave write indeed
+		   is a slave write. */
+		is_slave_write_complete = 1;
+#else
+		if (!(slave_status & XTCNTLSS_SDBF) && (ext_status & EXTSTS_BCS_MASK) == EXTSTS_BCS_SLAVESEL) {
+#warning This works, but I do not think it is supposed to work this way!
+			/* This is a very ugly hack, but is the only way
+			 * to determine a slave read operation with an
+			 * address byte before the read request. The
+			 * driver doesn't get a "slave read needs service"
+			 * interrupt in that case. Instead, a "slave write
+			 * complete" interrupt occurs (with a bus in slave
+			 * selected state according to EXTSTS).
+			 * So if the slave buffer is not full (meaning no
+			 * write transfer pending) and the bus is in
+			 * slave selected state, we assume a slave read
+			 * operation here.
+			 */
+			is_slave_read_request = 1;
+			slave_read_get_command = 1;
+		}
+		else {
+			is_slave_write_complete = 1;
+		}
+#endif
+	}
+	if (slave_status & XTCNTLSS_SRS) {
+		is_slave_read_request = 1;
+	}
+	if (slave_status & XTCNTLSS_SRC) {
+		is_slave_read_complete = 1;
+	}
+	
+	/* reset the flags */
+	slave_write_was_blocked = 0;
+	blocked_write_msg_complete = 0;
+	slave_read_was_blocked = 0;
+	blocked_read_msg_read_cmd = 0;
+	
+	/* performe the requested operation */
+	
+	if (block_next_slave_operation) {
+		/* we block the slave operation by not reading data
+		   and not resetting the slave status */
+		if (is_slave_write_request) {
+			slave_write_was_blocked = 1;
+		}
+		
+		if (is_slave_write_complete) {
+			slave_write_was_blocked = 1;
+			blocked_write_msg_complete = 1;
+		}
+		
+		if (is_slave_read_request) {
+			slave_read_was_blocked = 1;
+			blocked_read_msg_read_cmd = slave_read_get_command;
+		}
+
+		slave_status &= ~(XTCNTLSS_SWC | XTCNTLSS_SWS | XTCNTLSS_SRC | XTCNTLSS_SRS);
+	}
+	else {
+		if (is_slave_write_request || is_slave_write_complete) {
+			slave_status = iic_handle_slave_write(dev, slave_status);
+			if (slave_status & XTCNTLSS_SWC) {
+				if (iic_handle_slave_write_complete(dev) < 0) {
+					DBG("%d: cannot put data to i2c-slave layer, next operation will be blocked.\n",
+						dev->idx);
+					block_next_slave_operation = 1;
+				}
+			}
+		}
+		
+		if (is_slave_read_request) {
+			slave_status = iic_handle_slave_read(dev, slave_status, slave_read_get_command);
+		}
+		
+		if (slave_status & XTCNTLSS_SRC) {
+			iic_handle_slave_read_complete(dev);
+		}
+	}
+
+	out_8(&iic->xtcntlss, slave_status);
+
+	DBG2("%d: iic_handle_slave: done (slave_status=0x%02x)\n", dev->idx, slave_status);
+
+	spin_unlock_irqrestore(&slave_lock, flags);
+}
+
+
 module_init(iic_init);
 module_exit(iic_exit);
Index: pplinux/linuxnew/drivers/i2c/i2c-ibm_iic.h
diff -u pplinux/linuxnew/drivers/i2c/i2c-ibm_iic.h:1.1.323.1 pplinux/linuxnew/drivers/i2c/i2c-ibm_iic.h:1.2
--- pplinux/linuxnew/drivers/i2c/i2c-ibm_iic.h:1.1.323.1	Thu Feb  3 10:00:38 2005
+++ pplinux/linuxnew/drivers/i2c/i2c-ibm_iic.h	Thu Feb  3 11:35:37 2005
@@ -61,7 +61,12 @@
 /* IICx_EXTSTS register */
 #define EXTSTS_IRQP	0x80
 #define EXTSTS_BCS_MASK	0x70
-#define   EXTSTS_BCS_FREE  0x40
+#define   EXTSTS_BCS_SLAVESEL    0x10
+#define   EXTSTS_BCS_SLAVEXFER   0x20
+#define   EXTSTS_BCS_MASTERXFER  0x30
+#define   EXTSTS_BCS_FREE        0x40
+#define   EXTSTS_BCS_BUSYBUS     0x50
+#define   EXTSTS_BCS_UNKNOWN     0x60
 #define EXTSTS_IRQD	0x08
 #define EXTSTS_LA	0x04
 #define EXTSTS_ICT	0x02
@@ -85,6 +90,9 @@
 #define XTCNTLSS_SRS	0x40
 #define XTCNTLSS_SWC	0x20
 #define XTCNTLSS_SWS	0x10
+#define XTCNTLSS_SBDD	0x08
+#define XTCNTLSS_SDBF	0x04
+#define XTCNTLSS_EPI	0x02
 #define XTCNTLSS_SRST	0x01
 
 /* IICx_DIRECTCNTL register */
